function Kite(tID){
	var id = tID;
	
	var startX = (id+1) * (canvas.width/(noOfKites+1));
	var p = new PVector(startX,50);
	var pl = new PVector(0,0);
	var pr = new PVector(0,0);
	var ang = -Math.PI/2;
	var angTurn = 0.07;
	var speed = 9;
	var magVel = 0;
	
	var ll = new PVector(-10,-10);
	var rl = new PVector(-10,10);
	
	var v = new PVector(0,0); // 1,0
	var maxV = 4; //2
	
	var tail = [];
	var startTail = 5;
	var maxTail = 30;
	var tStripeLength = 5;
	var tailG = new PVector(0,0.3);
	var tailWaveAngle = 0;
	var stripeLength = 1;
	
	// clone for looping
	var pClone = new PVector(250,20);
	var plClone = new PVector(0,0);
	var prClone = new PVector(0,0);
	var tailClone = [];
	
	var c1;
	var c2;
	
	// strike variables
	var immune = false;
	var immuneMS = 500;
	var showStrike = false;
	var strikePoint = new PVector(0,0);
	var tailPiece = [];
	var strikeC1;
	var strikeC2;
	var pointsAdded;
	var showHitPoints = false;
	
	// glow tail points 
	var glowTail = [];
	var glowTimer = [];
	var glowActive = [];
	
	// scoring and points
	var points = 0;
	var leader = false;
	var leaderVariation = 0;
	
	this.setup = function(){
		for(var i = 0; i < startTail; i++){
			tail[i] = new PVector(0,(i*tStripeLength));
			tail[i].add(p);
		
			tailClone[i] = new PVector(0,0);
		}
		
		for(var i = 0; i < 10; i++){
			glowTail[i] = -1;
			glowActive[i] = false;
		}
		
		if(id == 0){
			c1 = 'red';
			c2 = 'rgba(127,0,0,1)';
		}
		if(id == 1){
			c1 = 'green';
			c2 = 'rgba(0,62,0,1)';
		}
		if(id == 2){
			c1 = 'orange';
			c2 = 'rgba(127,82,0,1)';
		}
		if(id == 3){
			c1 = 'pink';
			c2 = 'purple';
		}
	
		setInterval(function () {growTail()}, 1000);
	}
	
	var growTail = function(){
		if(tail.length < maxTail && !gameStart){
			tail[tail.length] = new PVector(0,0);
			tailClone[tailClone.length] = new PVector(0,0);
			if(tail.length == 1){
				tail[0].movePointBetween(pl,pr,0.5);
				tailClone[0].movePointBetween(plClone,prClone,0.5);
			}
			else{
				tail[tail.length-1].setXAndY(tail[tail.length-2].x,tail[tail.length-2].y);
				tailClone[tail.length-1].setXAndY(tailClone[tail.length-2].x,tailClone[tail.length-2].y);
			}
		}
	}
	
	this.setStartX = function(){
		startX = (id+1) * (canvas.width/(noOfKites+1));
		p.setXAndY(startX,p.y);
	}
	
	this.update = function(){	
		// turn with keyboard
		if(turnRight[id]){
			p.rotAround(pr,angTurn);
			pl.rotAround(pr,angTurn);
			ang += angTurn;
		}
		if(turnLeft[id]){
			p.rotAround(pl,-angTurn);
			pr.rotAround(pl,-angTurn);
			ang -= angTurn;
		}
		
		// turn with controller
		if(myPads[id] != null){
			// turn left
			if(myPads[id].buttons[6].pressed){
				//console.log("left");
				var value = myPads[id].buttons[6].value * 2;
				
				p.rotAround(pl,-angTurn*value);
				pr.rotAround(pl,-angTurn*value);
				ang -= angTurn*value;
			}
			
			// turn right
			if(myPads[id].buttons[7].pressed){
				var value = myPads[id].buttons[7].value * 2;
			
				//console.log("right");
				p.rotAround(pr,angTurn*value);
				pl.rotAround(pr,angTurn*value);
				ang += angTurn*value;
			}
		}
		
		
		magVel = 1-((canvas.height - p.y)/(canvas.height));
		magVel *= speed; // <---- change speed if using controllers
		
		// find heading
		v.setXAndY(1,0);
		v.rotate(ang);
		v.mult(magVel);

		p.add(v);
		
		if(p.y < 25){
			p.setXAndY(p.x,25);
		}
				
		this.loopWorld();
		
		// find points
		pl.makeEqualTo(p);
		pr.makeEqualTo(p);
		
		pl.add(ll);
		pr.add(rl);
		
		// rotate at current angle
		pl.rotAround(p,ang);
		pr.rotAround(p,ang);
		
		// update all pieces of fallen tail
		for(var i = 0; i < tailPiece.length; i++){
			tailPiece[i].update();
		}
		
		// remove fallen tail if necessary
		for(var i = tailPiece.length-1; i >= 0; i--){
			if(tailPiece[i].getRemove()){
				tailPiece.splice(i,1);
			}
		}
		
		//console.log(v.mag());		
	}
	
	this.groundCollision = function(){
		if(p.y > canvas.height*groundFromTop){
			showStrike = true;
			setTimeout(function(){showStrike = false;},100);
			strikeC1 = c1;
			strikeC2 = c2;
			strikePoint.makeEqualTo(p);
			
			addRipple(p);
			p.setXAndY(startX, 10);
			ang = -Math.PI/2;
			
			tail.splice(5,(tail.length-5));
			tailClone.splice(5,(tailClone.length-5));
			
			immune = true;
			setTimeout(function(){immune = false},immuneMS);
			
		}
	}
	
	this.hitTail = function(point,hittersID){
		for(var i = 0; i < tail.length; i++){
			if(!immune){

				if(dist(point,tail[i]) < tStripeLength + (kite[hittersID].getV()) || dist(point,tailClone[i]) + (kite[hittersID].getV()) < tStripeLength){
					
					//
					var hittersAngle = kite[hittersID].getAngle();
					var hittersSpeed = kite[hittersID].getSpeed();
					var hittersC1 = kite[hittersID].getC1();
					var hittersC2 = kite[hittersID].getC2();
					pointsAdded = kite[hittersID].getTailLength();
					
					// strike angle
					var strikeAngle = new PVector(5*(hittersSpeed+1),0);
					strikeAngle.rotate(hittersAngle + 0.1);
					
					// add new falling tail piece
					tailPiece[tailPiece.length] = new Tail(i,tail,c1,c2,stripeLength,tStripeLength,i%2,strikeAngle);
					//console.log(tailPiece);
					
					// remove from tail
					//console.log(id + ": hit at tail point " + i);
					immune = true;
					setTimeout(function(){immune = false},immuneMS);
					tail.splice(i,(tail.length-i));
					tailClone.splice(i,(tailClone.length-i));
					
					// create impact 
					impactPause = true;
					showStrike = true;
					strikeC1 = hittersC1;
					strikeC2 = hittersC2;
					strikePoint.makeEqualTo(point);
					strikePoint.add(strikeAngle);
					if(strikePoint.x < 0){
						strikePoint.setXAndY(strikePoint.x+canvas.width,strikePoint.y);
					}
					else if(strikePoint.x > canvas.width){
						strikePoint.setXAndY(strikePoint.x-canvas.width,strikePoint.y);
					}
					setTimeout(function(){impactPause = false;},50);
					setTimeout(function(){showStrike = false;},100);
					setTimeout(function(){addRipple(strikePoint);},25);
					
					// move end of tail
					strikeAngle.rotate(0.2);
					for(var i = tail.length-1; i > 0; i--){
						tail[i].add(strikeAngle);
						strikeAngle.limit(strikeAngle.mag()*0.8);
					}
					
					kite[hittersID].setIsHitter();
					
				}
			}
		}
	}
	
	this.setIsHitter = function(){
		if(!gameStart && !gameEnd){
			var glowDelay = 150;
		
			if(!glowActive[0]){ 
				glowActive[0] = true;
				glowTail[0] = 0;
				glowTimer[0] = setInterval(function(){
					glowTail[0]++; 
					if(glowTail[0] > tail.length){ 
						glowActive[0] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[0]-2)*10;
						}
						glowTail[0] = -1;
						clearInterval(glowTimer[0]);
					}
				},glowDelay);
			}
			else if(!glowActive[1]){
				glowActive[1] = true;
				glowTail[1] = 0;
				glowTimer[1] = setInterval(function(){
					glowTail[1]++; 
					if(glowTail[1] > tail.length){ 
						glowActive[1] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[1]-2)*10;
						}
						glowTail[1] = -1;
						clearInterval(glowTimer[1]);
					}
				},glowDelay);
			}
			else if(!glowActive[2]){
				glowActive[2] = true;
				glowTail[2] = 0;
				glowTimer[2] = setInterval(function(){
					glowTail[2]++; 
					if(glowTail[2] > tail.length){ 
						glowActive[2] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[2]-2)*10;
						}
						glowTail[2] = -1;
						clearInterval(glowTimer[2]);
					}
				},glowDelay);
			}
			else if(!glowActive[3]){
				glowActive[3] = true;
				glowTail[3] = 0;
				glowTimer[3] = setInterval(function(){
					glowTail[3]++; 
					if(glowTail[3] > tail.length){ 
						glowActive[3] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[3]-2)*10;
						}
						glowTail[3] = -1;
						clearInterval(glowTimer[3]);
					}
				},glowDelay);
			}
			else if(!glowActive[4]){
				glowActive[4] = true;
				glowTail[4] = 0;
				glowTimer[4] = setInterval(function(){
					glowTail[4]++; 
					if(glowTail[4] > tail.length){ 
						glowActive[4] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[4]-2)*10;
						}
						glowTail[4] = -1;
						clearInterval(glowTimer[4]);
					}
				},glowDelay);
			}
			else if(!glowActive[5]){
				glowActive[5] = true;
				glowTail[5] = 0;
				glowTimer[5] = setInterval(function(){
					glowTail[5]++; 
					if(glowTail[5] > tail.length){ 
						glowActive[5] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[5]-2)*10;
						}
						glowTail[5] = -1;
						clearInterval(glowTimer[5]);
					}
				},glowDelay);
			}
			else if(!glowActive[6]){
				glowActive[6] = true;
				glowTail[6] = 0;
				glowTimer[6] = setInterval(function(){
					glowTail[6]++; 
					if(glowTail[6] > tail.length){ 
						glowActive[6] = false;
						if(!gameStart && !gameEnd){
							points += (glowTail[6]-2)*10;
						}
						glowTail[6] = -1;
						clearInterval(glowTimer[6]);
					}
				},glowDelay);
			}
		}

	}
	
	this.setIsLeader = function(temp){
		leader = temp;
		
		if(points <= 0){
			leader = false;
		}
	}
	
	this.addPoints = function(){
		points+= (tail.length*10);
	}
	
	this.getP = function(){
		return p;
	}
	
	this.getCP = function(){
		return pClone;
	}	
	
	this.getAngle = function(){
		return ang;
	}
	
	this.getSpeed = function(){
		return magVel;
	}
	
	this.getC1 = function(){
		return c1;
	}
	
	this.getC2 = function(){
		return c2;
	}
	
	this.getTailLength = function(){
		return (tail.length*10);
	}
	
	this.getPoints = function(){
		return points;
	}
	
	this.getV = function(){
		return (v.mag());
	}
	
	this.loopWorld = function(){
		// loop world <------ temp
		if(p.x < -canvas.width * 0.5){
			// swap
			p.makeEqualTo(pClone);
			pl.makeEqualTo(plClone);
			pr.makeEqualTo(prClone);
			
			for(var i = 0; i < tail.length; i++){
				tail[i].makeEqualTo(tailClone[i]);
			}
			
		}
		if(p.x > canvas.width * 1.5){
			// swap
			p.makeEqualTo(pClone);
			pl.makeEqualTo(plClone);
			pr.makeEqualTo(prClone);
			
			for(var i = 0; i < tail.length; i++){
				tail[i].makeEqualTo(tailClone[i]);
			}
		}
	}
	
	
	
	this.updateTail = function(){
		
		var tOther = new PVector(0,0);
		var tWave = new PVector(1,0);
		
		// tail wave bit (may need improvement)
		tWave.rotate(ang - Math.PI);
		tWave.limit((1+Math.sin(tailWaveAngle))/2);
		
		tailWaveAngle += 0.05;
		if(tailWaveAngle > 2*Math.PI){
			tailWaveAngle -= 2*Math.PI;
		}
		///// end of twb
		
		if(tail.length > 0){
			tail[0].movePointBetween(pl,pr,0.5);
		}
		
		for(var i = 1; i < tail.length; i++){
			tOther.makeEqualTo(tail[i]);
			tOther.add(tailG);
			
			// tail wave bit may need improvement
			tWave.limit((((1+Math.sin(tailWaveAngle))/2)/i)*5);
			tOther.add(tWave);
			///// end of twb
		
			distB = dist(tOther,tail[i-1]);
		
			if(distB > tStripeLength){
				tail[i].movePointBetween(tOther,tail[i-1],1-(tStripeLength/distB));
			}
		}	
	}
	
	this.updateClone = function(){
		var offset = canvas.width;
		
		if(p.x < canvas.width/2){
			offset = -offset;
		}
	
		pClone.setXAndY(p.x - offset, p.y);
		prClone.setXAndY(pr.x - offset, pr.y);
		plClone.setXAndY(pl.x - offset, pl.y);
		
		for(var i = 0; i < tail.length; i++){
			tailClone[i].setXAndY(tail[i].x - offset, tail[i].y);
		}
	}
	

	this.display = function(){
      	context.beginPath();
      	context.moveTo(pl.x, pl.y);
      	context.lineTo(p.x, p.y);
      	context.lineTo(pr.x, pr.y);
      	if(showStrike){
      		context.strokeStyle = 'rgba(255,255,225,1)';
      	}
      	else{
      		context.strokeStyle = c1;
      	}
      	context.lineWidth = 3;
      	context.stroke();
      	
      	// display tail    	
      	var alt = 0;
      	for(var i = 0; i < tail.length-stripeLength; i+=stripeLength){	
			context.beginPath();
			context.moveTo(tail[i].x,tail[i].y);
			
			for(var j = i+1; j < i+stripeLength+1; j++){
				context.lineTo(tail[j].x,tail[j].y);
			}
		
			if(glowTail[0] == i || glowTail[1] == i || glowTail[2] == i || glowTail[3] == i || glowTail[4] == i || glowTail[5] == i || glowTail[6] == i){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
				
				// display score added next to current tail position
				context.font = 10 + 'pt Calibri';
				context.fillStyle = 'rgba(255,255,225,1)';
				var littlePoints = ' ' + ((i+1)*10) + ' ';
				context.fillText(littlePoints, tail[i].x - (20 * (v.x)/v.mag()) - (context.measureText(littlePoints).width/2), tail[i].y - (20 * v.y/v.mag()));
			}
			else if(showStrike){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
			}
			else if(alt%2 == 0){
				context.strokeStyle = c1;
				context.lineWidth = 3;
				context.stroke();
			}
			else{
				context.strokeStyle = c2;
				context.lineWidth = 3;
				context.stroke();
			}
			alt++;	
      	}
      	
      	// show if leader
		if(leader){		
			leaderVariation -= 0.1;
			
			if(leaderVariation < -2*Math.PI){
				leaderVariation += 2*Math.PI;
			}
			
			var leaderBright;
			for(var i = 0; i < tail.length; i++){
				leaderBright = (Math.sin(leaderVariation + (i*Math.PI/tail.length))+1)/2;
				context.beginPath();
				context.arc(tail[i].x, tail[i].y, 1.2, 0, 2 * Math.PI, false);
				context.fillStyle = 'rgba(255,255,225,'+ leaderBright +')';
				context.fill();
			}	
		}
      	
      	/////////////////////////CLONE
      	// display clone   	
      	context.beginPath();
      	context.moveTo(plClone.x, plClone.y);
      	context.lineTo(pClone.x, pClone.y);
      	context.lineTo(prClone.x, prClone.y);
      	if(showStrike){
      		context.strokeStyle = 'rgba(255,255,225,1)';
      	}
      	else{
      		context.strokeStyle = c1;
      	}
      	context.lineWidth = 3;
      	context.stroke();
      	
      	// display tail   	
      	alt = 0;
      	for(var i = 0; i < tailClone.length-stripeLength; i+=stripeLength){	
			context.beginPath();
			context.moveTo(tailClone[i].x,tailClone[i].y);
			
			for(var j = i+1; j < i+stripeLength+1; j++){
				context.lineTo(tailClone[j].x,tailClone[j].y);
			}
		
			if(glowTail[0] == i || glowTail[1] == i || glowTail[2] == i || glowTail[3] == i || glowTail[4] == i || glowTail[5] == i || glowTail[6] == i){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
				
				// display score added next to head
				context.font = 10 + 'pt Calibri';
				context.fillStyle = 'rgba(255,255,225,1)';
				var littlePoints = ' ' + ((i+1)*10) + ' ';
				context.fillText(littlePoints, tailClone[i].x - (20 * (v.x)/v.mag()) - (context.measureText(littlePoints).width/2), tailClone[i].y - (20 * v.y/v.mag()));
			}
			else if(showStrike){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
			}
			else if(alt%2 == 0){			
				context.strokeStyle = c1;
				context.lineWidth = 3;
				context.stroke();
			}
			else{
				context.strokeStyle = c2;
				context.lineWidth = 3;
				context.stroke();
			}
			alt++;	
      	}
      	
      	// show if leader
		if(leader){			
			var leaderBright;
			for(var i = 0; i < tail.length; i++){
				leaderBright = (Math.sin(leaderVariation + (i*Math.PI/tail.length))+1)/2;
				context.beginPath();
				context.arc(tailClone[i].x, tailClone[i].y, 1.2, 0, 2 * Math.PI, false);
				context.fillStyle = 'rgba(255,255,225,'+ leaderBright +')';
				context.fill();
			}	
		}
      	
      	
      	// display all pieces of fallen tail
		for(var i = 0; i < tailPiece.length; i++){
			tailPiece[i].display();
		}
		
		// strike point
		if(showStrike){
		
			var startS = new PVector(30,0);
			var endS = new PVector(35,0);
			var number = 16;
			
			startS.add(strikePoint);
			endS.add(strikePoint);
			
			for(var i = 0; i < number; i++){
				startS.rotAround(strikePoint,2*Math.PI/number);
				endS.rotAround(strikePoint,2*Math.PI/number);
				
				context.beginPath();
				context.moveTo(startS.x,startS.y);
				context.lineTo(endS.x,endS.y);
				
				if(i%2 == 0){
					context.lineWidth = 3;
					context.strokeStyle = c1;
					context.stroke();
				}
				else{
					context.lineWidth = 3;
					context.strokeStyle = 'rgba(255,255,225,1)'; // c2
					context.stroke();
				}
				
			}
		
			startS.setXAndY(20,0);
			endS.setXAndY(25,0);
			number = 8;
			
			startS.add(strikePoint);
			endS.add(strikePoint);
			startS.rotAround(strikePoint,Math.PI/number);
			endS.rotAround(strikePoint,Math.PI/number);
			
			for(var i = 0; i < number; i++){
				startS.rotAround(strikePoint,2*Math.PI/number);
				endS.rotAround(strikePoint,2*Math.PI/number);
				
				context.beginPath();
				context.moveTo(startS.x,startS.y);
				context.lineTo(endS.x,endS.y);
				
				if(i%2 == 0){
					context.lineWidth = 3;
					context.strokeStyle = strikeC1;
					context.stroke();
				}
				else{
					context.lineWidth = 3;
					context.strokeStyle = 'rgba(255,255,225,1)'; //strikeC2;
					context.stroke();
				}
				
			}
			
			
		}

		// display score		
		// (context.measureText(playerText).width/2)
		var playerText = 'P'+ (id+1);
		var pointsText = '' + points + '';
		
		context.font = '20pt Calibri';
		context.fillStyle = c1;
		context.fillText(playerText, startX - (context.measureText(playerText).width/2), canvas.height - 20);
		context.fillText(pointsText, startX - (context.measureText(pointsText).width/2), canvas.height - 45);
	}
	
	this.updateStable = function(){
		// turn
		if(turnRight){
			p.rotAround(pr,angTurn);
			pl.rotAround(pr,angTurn);
			ang += angTurn;
		}
		if(turnLeft){
			p.rotAround(pl,-angTurn);
			pr.rotAround(pl,-angTurn);
			ang -= angTurn;
		}
		
		// find heading
		w.setXAndY(1,0);
		w.rotate(ang);
		
		v.add(w);
		v.maxMag(2);
		
		p.add(v);
				
		this.loopWorld();
		
		// find points
		pl.makeEqualTo(p);
		pr.makeEqualTo(p);
		
		pl.add(ll);
		pr.add(rl);
		
		// rotate at current angle
		pl.rotAround(p,ang);
		pr.rotAround(p,ang);
		
	}
	
	var addRipple = function(starting){
		var makeNew = true;
		for(var i = 0; i < ripples.length && makeNew; i++){
			if(!ripples[i].getActive()){
				ripples[i].reset(starting);
				makeNew = false;
			}
		}
		
		if(makeNew){
			ripples[ripples.length] = new Ripple(starting);
		}
	}
}

